using System;
using K = System.Console; //Alias
//les collections sont dans System.Collections
using System.Xml.Serialization;
using System.IO;
using System.Collections;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;

public class Tests {
  public static void Main (String []a){
    K.WriteLine ("hello");

    DateTime dt = DateTime.Now;
    K.WriteLine (dt.ToString("f"));
    
    dt = dt.AddMinutes (50);

    K.WriteLine (dt.ToString("f"));

    //FichiersOut();
    //FichiersIn();
    FichiersOut2();
    FichiersIn2();

    XMLFichiersOut();
    K.WriteLine("TRACE 01");
    XMLFichiersIn();
    K.WriteLine("TRACE 02");


    SerializeObject("testXML.xml");
    DeserializeObject("testXML.xml");
  }

  public static void FichiersOut(){
    Personne [] tabPers = new Personne [5];
    

    for (int i = 0; i < tabPers.Length; i++)
      tabPers[i] = new Personne (i, "al");

   
    BinaryFormatter mySerializer = new BinaryFormatter();

    FileStream myWriter = new FileStream("mesDatas.test", FileMode.Create);
    
    mySerializer.Serialize(myWriter, tabPers);

    myWriter.Close();
  }
  public static void FichiersOut2(){
    Personne [] tabPers = new Personne [5];

    for (int i = 0; i < tabPers.Length; i++)
      tabPers[i] = new Personne (i, "al");

   
    BinaryFormatter mySerializer = new BinaryFormatter();

    FileStream myWriter = new FileStream("mesDatas.test", FileMode.Create);
    
    foreach (Personne p in tabPers)
      mySerializer.Serialize(myWriter,p);
    
    myWriter.Close();
  }
  
  public static void FichiersIn(){
    Personne [] tabPers;

    BinaryFormatter mySerializer = new BinaryFormatter();

    FileStream myWriter = new FileStream("mesDatas.test", FileMode.Open);
    
    tabPers = (Personne [])mySerializer.Deserialize(myWriter);

    myWriter.Close();

    foreach (Personne p in tabPers)
      Console.WriteLine (p);

  }

  public static void FichiersIn2(){
    //Personne [] tabPers;
    ArrayList tabPers = new ArrayList();

    BinaryFormatter mySerializer = new BinaryFormatter();

    FileStream myWriter = new FileStream("mesDatas.test", FileMode.Open);

    try {
      while (true) {
	tabPers.Add (mySerializer.Deserialize(myWriter));
      }
    }
    catch (SerializationException) {}

    myWriter.Close();

    foreach (Personne p in tabPers)
      Console.WriteLine (p);

  }


  public static void XMLFichiersOut(){
    Personnes p = new Personnes();

    for (int i = 0; i < 5; i++)
      p.Add(new Personne (i, "al"));

    XmlSerializer mySerializer = new XmlSerializer(typeof(Personnes));

    FileStream myWriter = new FileStream("mesDatas.xml", FileMode.Create);
    
    mySerializer.Serialize(myWriter, p);

    myWriter.Close();
  }

  public static void XMLFichiersIn(){
    
    Personne [] tabPers = new Personne[5];

    FileStream myWriter = new FileStream("mesDatas.xml", FileMode.Open);

    XmlSerializer mySerializer = new XmlSerializer(tabPers.GetType());
    
    tabPers = (Personne [])mySerializer.Deserialize(myWriter);

    myWriter.Close();

    foreach (Personne p in tabPers)
      Console.WriteLine (p);
    
  }

  public static XmlSerializer CreateOverrider()
    {
      // Creating XmlAttributeOverrides and XmlAttributes objects.
      XmlAttributeOverrides xOver = new XmlAttributeOverrides();
      XmlAttributes xAttrs = new XmlAttributes();

      // Add an override for the XmlArray.    
      XmlArrayAttribute xArray = new XmlArrayAttribute("XXX");
      xAttrs.XmlArray = xArray;
      xOver.Add(typeof(CTabPers), "YYY", xAttrs);

      // Create the XmlSerializer and return it.
      return new XmlSerializer(typeof(CTabPers), xOver);
    }
   
 
  public static void SerializeObject(string filename)
    {
      // Create an instance of the XmlSerializer class.
      XmlSerializer mySerializer =  CreateOverrider();
      // Writing the file requires a TextWriter.
      TextWriter writer = new StreamWriter(filename);

      // Create an instance of the class that will be serialized.
      CTabPers myCTabPers = new CTabPers();
      myCTabPers.tabPers = new Personne[5];

      // Set the object properties.
      for (int i = 0; i < 5; i++)
	myCTabPers.tabPers[i] = new Personne (i, "al" + i);
      
      K.WriteLine("trace dans erialize objects ...");
      // Serialize the class, and close the TextWriter.
      mySerializer.Serialize(writer, myCTabPers);
      writer.Close();
    }

  public static void DeserializeObject(string filename)
    {
      XmlSerializer mySerializer = CreateOverrider();
      FileStream fs = new FileStream(filename, FileMode.Open);
      CTabPers myCTabPers = (CTabPers)mySerializer.Deserialize(fs);
      foreach(Personne m in myCTabPers.tabPers)
	{
	  Console.WriteLine(m);
	}
    }
}


public class CTabPers {
  public Personne [] tabPers;
}

[Serializable]
public class Personne{
  public int age;
  public String nom;
  
  //OBLIGATOIRE pour la serialization
  public Personne() {
    nom = "defaut";
    age = -1;
  }

  public Personne (int a, String n) {
    age = a;
    nom = n;
  }

  public override String ToString() {
    return nom + "  " + age;
  }
}

public class Personnes:ICollection{
   public string CollectionName;
   private ArrayList empArray = new ArrayList(); 

   public Personne this[int index]{
      get{return (Personne) empArray[index];}
   }
   
   public void CopyTo(Array a, int index){
      empArray.CopyTo(a, index);
   }
   public int Count{
      get{return empArray.Count;}
   }
   public object SyncRoot{
      get{return this;}
   }
   public bool IsSynchronized{
      get{return false;}
   }
   public IEnumerator GetEnumerator(){
      return empArray.GetEnumerator();
   }

   public void Add(Personne newPersonne){
      empArray.Add(newPersonne);
   }
}

/*
class TempCollection:ICollection{
   public string CollectionName;
   private ArrayList empArray = new ArrayList(); 

   public T this[int index]{
      get{return (T) empArray[index];}
   }
   
   public void CopyTo(Array a, int index){
      empArray.CopyTo(a, index);
   }
   public int Count{
      get{return empArray.Count;}
   }
   public object SyncRoot{
      get{return this;}
   }
   public bool IsSynchronized{
      get{return false;}
   }
   public IEnumerator GetEnumerator(){
      return empArray.GetEnumerator();
   }

   public void Add(T newT){
      empArray.Add(newT);
   }

}
*/
