import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

/*
 *@author Julien Pusniak - Alain Vizzini
 *@version 0.1
 *Classe InterfaceAgandah: Cree l interface utilisateur pour la creation et l utilisation d agenda hospitalier.
 *
 */

public class InterfaceAgandah extends JFrame{ // definition du cadre
    

    //////////////////Des couleurs pour faire plus joli.//////////////////
    private static Color bleu=new Color(100,150,50);

    private JComboBox jComboBoxChoixJour=null; 
    private JComboBox jComboBoxChoixMois=null;
    private JComboBox jComboBoxChoixAnnee=null;
    private JComboBox jComboBoxChoixHeure=null;
    private JComboBox jComboBoxChoixMinute=null;
    private JTextField jTextFieldPersonName;
    private JList jListComment;



   public InterfaceAgandah(){ //methode constructeur

       setTitle("Agandah version 0.1");
       setSize(1000,500);//on definit la taille de la frame principale...
      
       Dimension screenSize=getToolkit().getScreenSize();
       setLocation(screenSize.width/2-500,screenSize.height/2-250);
  
       Component priseInfo=buttonRdV();
       priseInfo.setSize(100,500);
       getContentPane().add(priseInfo, BorderLayout.CENTER);
       getContentPane().add(choixDate(),BorderLayout.WEST);
       getContentPane().add(creationJList(),BorderLayout.SOUTH);
       setResizable(false);//on interdit la modification de taille par l utilisateur.

       setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
       addWindowListener (new WindowAdapter() {
	       public void windowClosing (WindowEvent e) {
		    if (RendezVous.sauver() && ConsultationPediatrie.sauver() && ConsultationRadiologie.sauver())
			JOptionPane.showMessageDialog(null, "Sauvegarde effectue avec succs.\n\n** Au revoir !! **", "Agandah message", JOptionPane.INFORMATION_MESSAGE);
		    else
			JOptionPane.showMessageDialog(null, "Erreur ! Sauvegarde impossible. Contactez l'admin (ou pleurez).\n\n** Au revoir !! **", "Agandah message", JOptionPane.ERROR_MESSAGE);		    
	       }

	       public void windowOpened (WindowEvent e) {
		    if (RendezVous.charger() && ConsultationPediatrie.charger() && ConsultationRadiologie.charger())
			JOptionPane.showMessageDialog(null, "Chargement effectue avec succs.\nL'agenda a t charg.", "Agandah message", JOptionPane.INFORMATION_MESSAGE);
		    else
			JOptionPane.showMessageDialog(null, "Erreur ! Chargement impossible. Contactez l'admin (ou pleurez).\n** Ignorez cette erreur si c'est la premire excution de l'agandah **", "Agandah message", JOptionPane.ERROR_MESSAGE);		    

	       }

	   });
       pack();
       setVisible(true);
   }
   
    /*
     *Cree le composant qui va permettre les fonctionalites de l' agenda
     *@return Component : le composant (JPanel) a ajouter.
     */
    public Component buttonRdV(){

	//------------Creation et ajout des boutons gerant la creation de rendez-vous-------------
	JButton jButtonRadio;
	JButton jButtonPedia;

	jButtonRadio=new JButton("Radiologie");
	jButtonRadio.setBackground(Color.lightGray);
	jButtonRadio.setToolTipText("Pour prendre un rendez-vous en radiologie.");
	
	jButtonPedia=new JButton("Pdiatrie");
	jButtonPedia.setBackground(Color.lightGray);
	jButtonPedia.setToolTipText("Pour prendre un rendez-vous en pdiatrie.");

	JLabel jLabelPriseRdV=new JLabel("Prendre un rendez-vous:");
	JPanel jPanelButtonRdV = new JPanel();
	jPanelButtonRdV.setBorder(BorderFactory.createEmptyBorder(
                                        30, //top
                                        30, //left
                                        10, //bottom
                                        30) //right
                                        );
        jPanelButtonRdV.setLayout(new GridLayout(0, 2));
        jPanelButtonRdV.add(jLabelPriseRdV);
	jPanelButtonRdV.add(new JLabel(""));
        jPanelButtonRdV.add(jButtonPedia);
	jButtonPedia.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		if (jTextFieldPersonName.getText().equals("")){
		    JOptionPane.showMessageDialog(null, "Vous DEVEZ spcifier un nom de patient.", "Agandah message", JOptionPane.ERROR_MESSAGE);
		    return;
		}
		    
		String msg = ConsultationPediatrie.prendreRendezVous (
									    Integer.parseInt((String)jComboBoxChoixAnnee.getSelectedItem()),
									    jComboBoxChoixMois.getSelectedIndex(),
									    Integer.parseInt((String)jComboBoxChoixJour.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixHeure.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixMinute.getSelectedItem()),
									    jTextFieldPersonName.getText());

		JOptionPane.showMessageDialog(null, msg, "Agandah message", JOptionPane.PLAIN_MESSAGE);


		ConsultationPediatrie.lister();
            }
        });

	jPanelButtonRdV.add(jButtonRadio);
	jButtonRadio.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
		if (jTextFieldPersonName.getText().equals("")){
		    JOptionPane.showMessageDialog(null, "Vous DEVEZ spcifier un nom de patient.", "Agandah message", JOptionPane.ERROR_MESSAGE);
		    return;
		}
		    
		String msg = ConsultationRadiologie.prendreRendezVous (
									    Integer.parseInt((String)jComboBoxChoixAnnee.getSelectedItem()),
									    jComboBoxChoixMois.getSelectedIndex(),
									    Integer.parseInt((String)jComboBoxChoixJour.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixHeure.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixMinute.getSelectedItem()),
									    jTextFieldPersonName.getText());

		JOptionPane.showMessageDialog(null, msg, "Agandah message", JOptionPane.PLAIN_MESSAGE);


		ConsultationRadiologie.lister();
            }
        });


	//------------Creation et ajout des fonctionnalites d' annulation----------------



	JLabel jLabelAnnulRdV=new JLabel("Annuler rendez-vous:");
	JButton jButtonAnnulRdVPed=new JButton("Annuler pdiatrie");
	jButtonAnnulRdVPed.setBackground(Color.lightGray);
	jButtonAnnulRdVPed.setToolTipText("Annuler le rendez-vous du patient en pdiatrie.");

	JButton jButtonAnnulRdVRadio=new JButton("Annuler radiologie");
	jButtonAnnulRdVRadio.setToolTipText("Annuler le rendez-vous du patient en radiologie.");
	jButtonAnnulRdVRadio.setBackground(Color.lightGray);

	jPanelButtonRdV.add(jLabelAnnulRdV);
	jPanelButtonRdV.add(new JLabel(""));
	jPanelButtonRdV.add(jButtonAnnulRdVPed);

	jButtonAnnulRdVPed.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		if (jTextFieldPersonName.getText().equals("")){
		    JOptionPane.showMessageDialog(null, "Vous DEVEZ spcifier un nom de patient.", "Agandah message", JOptionPane.ERROR_MESSAGE);
		    return;
		}
		    
		    String msg = ConsultationPediatrie.annulerRendezVous (
									    Integer.parseInt((String)jComboBoxChoixAnnee.getSelectedItem()),
									    jComboBoxChoixMois.getSelectedIndex(),
									    Integer.parseInt((String)jComboBoxChoixJour.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixHeure.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixMinute.getSelectedItem()),
									    jTextFieldPersonName.getText());
		    
		    JOptionPane.showMessageDialog(null, msg, "Agandah message", JOptionPane.PLAIN_MESSAGE);


		    ConsultationPediatrie.lister();
		}
	    });

	
	jPanelButtonRdV.add(jButtonAnnulRdVRadio);
	jButtonAnnulRdVRadio.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		if (jTextFieldPersonName.getText().equals("")){
		    JOptionPane.showMessageDialog(null, "Vous DEVEZ spcifier un nom de patient.", "Agandah message", JOptionPane.ERROR_MESSAGE);
		    return;
		}
		    
		    String msg = ConsultationRadiologie.annulerRendezVous (
									    Integer.parseInt((String)jComboBoxChoixAnnee.getSelectedItem()),
									    jComboBoxChoixMois.getSelectedIndex(),
									    Integer.parseInt((String)jComboBoxChoixJour.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixHeure.getSelectedItem()),
									    Integer.parseInt((String)jComboBoxChoixMinute.getSelectedItem()),
									    jTextFieldPersonName.getText());
		    
		    JOptionPane.showMessageDialog(null, msg, "Agandah message", JOptionPane.PLAIN_MESSAGE);


		    ConsultationRadiologie.lister();
		}
	    });


	//--------------Creation et ajout des composants gerant les differents types d' affichage-----------------------



	JLabel jLabelAfficher=new JLabel("Choisissez l' lment  afficher: ");
	JButton jButtonAffPedia = new JButton("Service de pdiatrie");
	jButtonAffPedia.setToolTipText("Affiche tous les rendez-vous du service de pdiatrie.");
	jButtonAffPedia.setBackground(Color.lightGray);

	jButtonAffPedia.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jListComment.setListData (ConsultationPediatrie.ihmLister());
		}
	    });

	JButton jButtonAffRadio = new JButton("Service de radiologie");
	jButtonAffRadio.setToolTipText("Affiche tous les rendez-vous du service de radiologie.");
	jButtonAffRadio.setBackground(Color.lightGray);

	jButtonAffRadio.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jListComment.setListData (ConsultationRadiologie.ihmLister());
		}
	    });


	JButton jButtonSuiviAnnul=new JButton("Suivi annulation");
	jButtonSuiviAnnul.setToolTipText("Affiche tous les rendez-vous annul");
	jButtonSuiviAnnul.setBackground(Color.lightGray);
	jButtonSuiviAnnul.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jListComment.setListData (RendezVous.ihmListerAnnules());
		}
	    });
	JButton jButtonRechPatient=new JButton("Recherche Patient");
	jButtonRechPatient.setToolTipText("Affiche tous les rendez-vous du patient.");
	jButtonRechPatient.setBackground(Color.lightGray);
	jButtonRechPatient.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    Vector v = ConsultationPediatrie.rechercherRendezVous(jTextFieldPersonName.getText());
		    v.addAll (ConsultationRadiologie.rechercherRendezVous(jTextFieldPersonName.getText()));
		    jListComment.setListData (v);
		    
		}
	    });
	jPanelButtonRdV.add(jLabelAfficher);
	jPanelButtonRdV.add(new JLabel(""));
	jPanelButtonRdV.add(jButtonAffPedia);
	jPanelButtonRdV.add(jButtonAffRadio);
	jPanelButtonRdV.add(jButtonSuiviAnnul);
	jPanelButtonRdV.add(jButtonRechPatient);


	//--------------Ajout et creation des composants permettant le chargement et la sauvegarde des agendas-----------------------

	JLabel jLabelOption=new JLabel("Options:");
	JButton jButtonSave=new JButton("Enregistrer");
	jButtonSave.setToolTipText("Enregistre les rendez-vous des services.");
	jButtonSave.setBackground(Color.lightGray);
	jButtonSave.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    if (RendezVous.sauver() && ConsultationPediatrie.sauver() && ConsultationRadiologie.sauver())
			JOptionPane.showMessageDialog(null, "Sauvegarde effectue avec succs", "Agandah message", JOptionPane.INFORMATION_MESSAGE);
		    else
			JOptionPane.showMessageDialog(null, "Erreur ! Sauvegarde impossible. Contactez l'admin (ou pleurez).", "Agandah message", JOptionPane.ERROR_MESSAGE);		    
		}
	    });

	JButton jButtonLoad=new JButton("Charger");
	jButtonLoad.setToolTipText("Charge un agenda sauvegard");
	jButtonLoad.setBackground(Color.lightGray);
	jButtonLoad.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    if (RendezVous.charger() && ConsultationPediatrie.charger() && ConsultationRadiologie.charger())
			JOptionPane.showMessageDialog(null, "Chargement effectue avec succs", "Agandah message", JOptionPane.INFORMATION_MESSAGE);
		    else
			JOptionPane.showMessageDialog(null, "Erreur ! Chargement impossible. Contactez l'admin (ou pleurez).", "Agandah message", JOptionPane.ERROR_MESSAGE);		    
		}
	    });

	jPanelButtonRdV.add(jLabelOption);
	jPanelButtonRdV.add(new JLabel(""));
	jPanelButtonRdV.add(jButtonSave);
	jPanelButtonRdV.add(jButtonLoad);


	return jPanelButtonRdV;     
    }	

    /**
     *Cree les composants qui vont permettre de prendre des renseignements sur le rendez vous a prendre.
     *@return Component : le composant (JPanel) a ajouter.
     */
    public Component choixDate(){
	
	
	//-----------Creation des composants pour determiner les particuliers de la personne et/ou du rendez-vous------------------

	jTextFieldPersonName=new JTextField();

	JLabel jLabelJour=new JLabel("Choix du jour");
	String[] jours=new String[31];
	for(int i=1;i<=31;i++){
	    jours[i-1]=""+i;
	}

	jComboBoxChoixJour=new JComboBox(jours);
	jComboBoxChoixJour.setSize(5,5);
	jLabelJour.setLabelFor(jComboBoxChoixJour);

	JLabel jLabelMois=new JLabel("Choix du mois");
	String[] mois={"janvier","fvrier","mars","avril","mai","juin","juillet","aout","septembre","octobre","novembre","dcembre"};
	jComboBoxChoixMois=new JComboBox(mois);
	jLabelMois.setLabelFor(jComboBoxChoixMois);

	JLabel jLabelAnnee=new JLabel("Choix de l'annee");
	String[] annee={"2002","2003","2004","2005","2006"};
	jComboBoxChoixAnnee=new JComboBox(annee);
	jLabelAnnee.setLabelFor(jComboBoxChoixAnnee);

	JLabel jLabelHeure=new JLabel("Choix de l' heure");
	String[] heures=new String[24];
	for(int i=0;i<24;i++){
	    heures[i]="" +i;
	}
	jComboBoxChoixHeure=new JComboBox(heures);
	jLabelHeure.setLabelFor(jComboBoxChoixHeure);



	JLabel jLabelMinute=new JLabel("Choix des minutes");
	String[] minutes=new String[60];
	for(int i=0;i<60;i++){
	    minutes[i]=""+i;
	}
	jComboBoxChoixMinute=new JComboBox(minutes);
	jLabelMinute.setLabelFor(jComboBoxChoixMinute);



	JPanel jPanelDate = new JPanel();
        jPanelDate.setBorder(BorderFactory.createEmptyBorder(
                                        30, //top
                                        30, //left
                                        10, //bottom
                                        30) //right
                                        );

        jPanelDate.setLayout(new GridLayout(0, 2));
	jComboBoxChoixJour.setBackground(Color.lightGray);
	jComboBoxChoixMois.setBackground(Color.lightGray);
	jComboBoxChoixAnnee.setBackground(Color.lightGray);
	jComboBoxChoixHeure.setBackground(Color.lightGray);
	jComboBoxChoixMinute.setBackground(Color.lightGray);

	

	//----------Ajout des composants d' identification au panel jPanelDate-----------------

	jPanelDate.add(new JLabel("Nom du patient"));
        jPanelDate.add(jTextFieldPersonName);
	
	jPanelDate.add(new JLabel("Choix du jour"));
	jPanelDate.add(jComboBoxChoixJour);

	jPanelDate.add(new JLabel("Choix du mois"));
	jPanelDate.add(jComboBoxChoixMois);

	jPanelDate.add(new JLabel("Choix de l' anne"));
	jPanelDate.add(jComboBoxChoixAnnee);

	jPanelDate.add(new JLabel("choix de l' heure..."));
	jPanelDate.add(jComboBoxChoixHeure);

	jPanelDate.add(new JLabel("Choix des min"));
	jPanelDate.add(jComboBoxChoixMinute);



	return jPanelDate;  
    }

    
    /**
     * Cree les composants qui vont permettre de donner des informations a l' utilisateur.
     * @return Component : le composant (JPanel) a jouter.
     */

    public Component creationJList(){
	jListComment=new JList();
	JPanel jPanelComment = new JPanel();
        jPanelComment.setBorder(BorderFactory.createEmptyBorder(
								30, //top
								30, //left
								10, //bottom
								30) //right
				);

        jPanelComment.setLayout(new GridLayout(0, 1));
	jPanelComment.add(new JLabel("Compte-rendu:"));
	jPanelComment.add(jListComment);
	return jPanelComment;
    }


    public static void main(String[] args) {
	InterfaceAgandah frame = new InterfaceAgandah();
    }
}	
